/*
    csymulti.ch

    Class(y) v2.4 multiple inheritance-specific command definitions

    Copyright (c) 1991-1994 Anton van Straaten

	Defines the following commands:

		VAR...[IS...] IN
		MESSAGE...[IS...] IN
		CLASS VAR...[IS...] IN
		CLASS MESSAGE...[IS...] IN
*/

#ifndef CSY_EXPORTED
#include "classy2.ch"
#endif


#command    VAR <(name1)> [, <(nameN)>] IN <class> [<ro: READONLY, RO>] [ASSIGN <assignScope>] [<in: INTERNAL>] ;
                => ;
				CsyAddDeleg( self, CSY_VARSCOPE( <.in.>, <.ro.> [, <assignScope>] ),, <class>(),, <(name1)> [, <(nameN)>] )

#command    VAR <(name)> IS <(tgtName)> IN <class> [<ro: READONLY, RO>] [ASSIGN <assignScope>] [<in: INTERNAL>] ;
                => ;
				CsyAddDeleg( self, CSY_VARSCOPE( <.in.>, <.ro.> [, <assignScope>] ),, <class>(), <(tgtName)>, <(name)> )

#command    CLASS VAR <(name1)> [, <(nameN)>] IN <class> [<ro: READONLY, RO>] [ASSIGN <assignScope>] [<in: INTERNAL>] ;
                => ;
				CsyAddDeleg( metaClass, CSY_VARSCOPE( <.in.>, <.ro.> [, <assignScope>] ),, <class>():class,, <(name1)> [, <(nameN)>] )

#command    CLASS VAR <(name)> IS <(tgtName)> IN <class> [<ro: READONLY, RO>] [ASSIGN <assignScope>] [<in: INTERNAL>] ;
                => ;
				CsyAddDeleg( metaClass, CSY_VARSCOPE( <.in.>, <.ro.> [, <assignScope>] ),, <class>():class, <(tgtName)>, <(name)> )

#command    MESSAGE <(name1)> [, <(nameN)>] IN <class> [<ro: READONLY, RO>] [ASSIGN <assignScope>] [<ac: ACCESS>] ;
                => ;
				CsyAddDeleg( self, CSY_METHSCOPE( <.ac.> ),,,, <class>(),, <(name1)> [, <(nameN)>] )

#command    MESSAGE <(name)> IS <(tgtName)> IN <class> [<ac: ACCESS>] ;
                => ;
				CsyAddDeleg( self, CSY_METHSCOPE( <.ac.> ),,,, <class>(), <(tgtName)>, <(name)> )

#command    CLASS MESSAGE <(name1)> [, <(nameN)>] IN <class> [<ro: READONLY, RO>] [ASSIGN <assignScope>] [<ac: ACCESS>] ;
                => ;
				CsyAddDeleg( metaClass, CSY_METHSCOPE( <.ac.> ),,,, <class>():class,, <(name1)> [, <(nameN)>] )

#command    CLASS MESSAGE <(name)> IS <(tgtName)> IN <class> [<ac: ACCESS>] ;
                => ;
				CsyAddDeleg( metaClass, CSY_METHSCOPE( <.ac.> ),,,, <class>():class, <(tgtName)>, <(name)> )


// eof csymulti.ch
